////////////////////////////////////////////////////////////////////////////////
//
//    Unicode Text Manipulation - Core file
//
//  (c) Copyright 2004 Point Mad. All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////
unit utext;

interface

uses Sysutils,cTypes;

{$LINK utext.o}

const
  COMBUF_TEXT_SIZE = 255;

type
  l_utext = String;
  l_short = Byte;
  l_ulong = Cardinal;

var
  CommonBufferUText: array[0..COMBUF_TEXT_SIZE] of l_short;

function UTextLen( t: String ): l_ulong; cdecl; external;

function UTextChr( t: l_utext; c: l_short ): l_utext; cdecl; external;

function UTextRChr( t: l_utext; c: l_short ): l_utext; cdecl; external;
function UTextCompare ( a: l_utext; b: l_utext ): Longint; cdecl; external;

function UTextNCompare ( a: l_utext; b: l_utext; n: l_ulong ): Longint; cdecl; external;

function UTextCaseCompare ( a: l_utext; b: l_utext ): Longint; cdecl; external;
function UTextNCaseCompare ( a: l_utext; b: l_utext; n: l_ulong ): Longint; cdecl; external;
function UTextSqNCaseCompare ( sq: l_utext; t: l_utext; n: l_ulong ): Longint; cdecl; external;
function UTextCopy ( d: l_utext; s: l_utext ): l_utext; cdecl; external;

function UTextNCopy ( d: l_utext; s: l_utext; n: l_ulong ): l_utext; cdecl; external;

function UTextDup ( t: l_utext ): l_utext; cdecl; external;

function UTextNDup ( t: l_utext; n: l_ulong ): l_utext; cdecl; external;

function UTextCat ( d: l_utext; t: l_utext ): l_utext; cdecl; external;

function UTextToUpper( d: l_utext ): l_utext; cdecl; external; (******* Das rufe ich im Testprogramm auf!!!!!! **********)

function UTextToLower( d: l_utext ): l_utext; cdecl; external;

function UToLower ( c: l_short ): l_short; cdecl; external;

function UToUpper ( c: l_short ): l_short; cdecl; external;

implementation
{
function UTextLen( t: String ): l_ulong;
var
  l: l_ulong;
begin
	l := Length(t);
	UTextLen := l;
end;

function UTextChr( t: l_utext; c: l_short ): l_utext;
var
  i: Integer;
begin
  i := 1;
  if Length(t) = 0 then UTextChr := IntToStr(0) else
  while i < length(t) do
  begin
    if t[i] = Chr(c) then
    begin
      UTextChr := IntToStr(i);
      i := Length(t);
    end;
    inc(i);
  end;
end;

function UTextRChr( t: l_utext; c: l_short ): l_utext;
var i: Integer;
begin
  i := Length(t);
  UTextRChr := IntToStr(0);
  while i>0 do
  begin
    if t[i] = Chr(c) then
    begin
      UTextRChr := IntToStr(i);
      i := 0;
    end;
    dec(i);
  end;
end;

function UTextCompare ( a: l_utext; b: l_utext ): Longint;
begin
  if a<b then UTextCompare := -1 else
  if a>b then UTextCompare := +1 else
  UTextCompare := 0;
end;
}
(*
// Compare 2 texts a and b on length n, return 0 if identical
function UTextNCompare ( a: l_utext; b: l_utext; n: l_ulong ): Longint; external;

// Compare 2 texts a and b, return 0 if identical
function UTextCaseCompare ( a: l_utext; b: l_utext ): Longint; external;


// Compare 2 texts a and b on length n, return 0 if identical
function UTextNCaseCompare ( a: l_utext; b: l_utext; n: l_ulong ): Longint; external;

// Compare a sequence (sq,n) and a text t, return 0 if identical,
function UTextSqNCaseCompare ( sq: l_utext; t: l_utext; n: l_ulong ): Longint; external;

// Copy text s to text d, return d
function UTextCopy ( d: l_utext; s: l_utext ): l_utext; external;

// Copy text s to text d of n chars, add \0 at end ,return d
function UTextNCopy ( d: l_utext; s: l_utext; n: l_ulong ): l_utext; external;

// Make a copy of string t in a new memory allocation
function UTextDup ( t: l_utext ): l_utext; external;

// Make a copy of n chars of text t in a new memory allocation (add \0 at end)
function UTextNDup ( t: l_utext; n: l_ulong ): l_utext; external;

// Add text t at the text d end, text d must have enouf memory allocated
function UTextCat ( d: l_utext; t: l_utext ): l_utext; external;

// Transform text to upper case
function UTextToUpper( d: l_utext ): l_utext; external;

// Transform text to lower case
function UTextToLower( d: l_utext ): l_utext; external;

function UToLower ( c: l_short ): l_short; external;

function UToUpper ( c: l_short ): l_short; external;
*)
end.
